<?php
/*
NetworX - open-source social networks platform
Copyright (C) 2009 SocialABC, Inc. http://www.socialabc.com
This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License along with this program in a file called LICENSE; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/ 


$section = 'my_connections';

include('includes/application_top.php');

if (!Session::isCurrentSessionLoggedIn())
{
	cmn_unauthorized_action();
}

$template->setVariable('SectionHeader',	'Add New Friends');	

switch (strtolower($_GET['entity']))
{		
	case 'organization':
	case 'group':
	
		$target = Entity::getObject($_GET['entity'], $_GET['id']);

		if ($target->{db_get_entity_key($target)} != -1)
		{
			$template->setVariable('ChangeTabLink',	
				cmn_self_link('display', '', array('request', 'remove')));
			
			$entities = array('Group' => 0, 'Organization' => 0, 'Community' => 0);
			$display  = isset($_GET['display']) ? strtolower($_GET['display']) : 'group';
			
			switch ($display)
			{
				case 'organization':
				case 'community':
				case 'group':
				
					$template->touchBlock($display . '_selected');					
					
					if (isset($_GET['request']))
					{
						$obj = Entity::getObject($display, $_GET['request']);
						if ($obj->{db_get_entity_key($obj)} != -1)
						{
							if (get_class($obj) == 'Community')
							{
								$target->addCommunity($obj->CommunityID);
							}
							else
							{
								if ($obj->isJoinRequested($target->{db_get_entity_key($target)}, 
									get_class($target)))
								{
									$template->setVariable('RequestName', $obj->{db_get_entity_name($obj)});
									$template->parse('error_already_requested');
								}
								else
								{
									cmn_redirect((get_class($obj) == 'Organization' ? 
										'organization' : 'group') . 
										'_request.php?entity=' . strtolower(get_class($target)) . '&id=' . 
										$target->{db_get_entity_key($target)} . '&request_id=' . 
										$obj->{db_get_entity_key($obj)} . '&return=' . 
										urlencode(cmn_self_link('', '', array('request'))));
								}
							}
						}
					}
					else if (isset($_GET['remove']))
					{
						$obj = Entity::getObject($display, $_GET['remove']);
						if ($obj->{db_get_entity_key($obj)} != -1)   
						{    
							$target->{'remove' . get_class($obj)}($obj->{db_get_entity_key($obj)});
						}
					}
				
					$db = DBConnect::getInstance();
					
					foreach ($entities as $entity => $count)
					{          
						$table = strtolower($entity);
						
			            $where = '';
						
			            switch ($table)	
			            {
			                case 'organization':
			                    $where = 'OrganizationActive = ' . ORGANIZATION_ACTIVE_ACCEPTED;
			                    break;
			                    
			                case 'group':
			                    $where = 'GroupStatus != ' . GROUP_STATUS_PRIVATE;
			            }
                        						
						if ($table == $display)
						{
							$listing = new Listing('listing.add_connection.html', 'listing');  
							$listing->onBeforeParseRow = parseConnection;                                 							
							$listing->parse($template, 'select ' . $entity . 'Created as Created, ' . 
								$entity . 'Updated as Updated, ' . $entity . 'Picture as Picture, \'' . 
								$entity . '\' as Entity, co.' . $entity . 
								'Name' . ' as Title, co.' . $entity . 
								'ID as ID from `' . $table . '` co ' . 								
								(!empty($where) ? ' where ' . $where : '') . 
								' group by co.' . $entity . 'ID');
							
							$entities[$entity] = $listing->DataSource->Size;     
						}
						else
						{
							$result = $db->query('select count(*) as cnt from `' . $table . '` co ' . 
								(!empty($where) ? ' where ' . $where : ''));
							$entities[$entity] = $result->Data[0]['cnt'];
						}
					}

					foreach ($entities as $entity => $count)
					{
						$template->setVariable($entity . 'Count', intval($count));
					}
					
			}
		}
		else
		{
			cmn_unathorized_action();
		}
		break;
		
	default:
		cmn_unathorized_action();
}


function parseConnection($tpl, $row)
{
	global $target;

	$obj = Entity::getObject($row['Entity'], $row['ID']);

	switch ($row['Entity'])
	{
		case 'Group':

			$tpl->setVariable('MembersLink', cmn_get_profile_link('Group', $row['ID']));
			$tpl->setVariable('MembersCount',
				count
				(
					Connection::getConnections
					(
						array
						(
							'ConnectionType'	=> array(CONNECTIONTYPE_OWNER, CONNECTIONTYPE_ADMIN, CONNECTIONTYPE_MEMBER),
							'UserID'			=> '<> -1',
							'GroupID'			=> $row['ID']
						)
					)
				)
			);

			$tpl->parse('size');

		case 'Organization':
        case 'Community':

        	if (($obj->{db_get_entity_key($obj)} != $target->{db_get_entity_key($target)}) ||
        		(get_class($obj) != get_class($target)))
        	{
				if ($target->{'has' . get_class($obj)}($obj->{db_get_entity_key($obj)}))
				{
					$tpl->setVariable('RequestLink', cmn_self_link('remove', $row['ID'], array('request')));
					$tpl->parse('remove_connection');
				}
				else
				{
					if (get_class($obj) == 'Community')
					{
						$tpl->setVariable('RequestLink', cmn_self_link('request', $row['ID'], array('remove')));
						$tpl->parse('add_connection');
					}
					else
					{
						if (!$obj->isJoinRequested($target->{db_get_entity_key($target)}, get_class($target)))
						{
							$tpl->setVariable('RequestLink', cmn_self_link('request', $row['ID'], array('remove')));
							$tpl->parse('add_connection');
						}
						else
						{
							$tpl->touchBlock('connection_pending');
						}
					}
				}
			}
	}

	$tpl->setVariable('EntityLink', cmn_get_profile_link($row['Entity'], $row['ID']));
	$db = DBConnect::getInstance();
	$result = $db->query('select * from `connection` where (ConnectionType = %d or ConnectionType = %d or ConnectionType = %d) ' .
		'and (' . $row['Entity'] . 'ID' . ' = %d or To' . $row['Entity'] . 'ID' . ' = %d) and UserID = -1 limit 5',
		CONNECTIONTYPE_MEMBER, CONNECTIONTYPE_ADMIN, CONNECTIONTYPE_OWNER, $row['ID'], $row['ID']);

	foreach ($result->Data as $data)
	{
		$connection = new Connection();
		$connection->populateFromArray($data);

		$link = $connection->getTarget($obj);

		$tpl->setVariable('ConnectionLink', cmn_get_profile_link(get_class($link), $link->{db_get_entity_key($link)}));
		$tpl->setVariable('ConnectionTitle', $link->{db_get_entity_name($link)});
		$tpl->parse('connection');
	}

	if (!count($result->Data))
	{
		$tpl->touchBlock('connections_none');
	}
	//////

	if (empty($row['Picture']))
	{
		$tpl->touchBlock('no_picture');
		$tpl->hideBlock('picture');
	}
}
include('includes/application_bottom.php');