<?php
/*
NetworX - open-source social networks platform
Copyright (C) 2009 SocialABC, Inc. http://www.socialabc.com
This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License along with this program in a file called LICENSE; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/ 

require_once('includes/admin_top.php');

switch ($_POST['mode'])
{
    case 'delete':
    case 'save':
        $obj = new Complaint($_POST['ComplaintID']);
        $obj->populateFromArray($_POST);
        
        switch ($_POST['mode'])
        {
            case 'delete':
                $obj->delete();
                break;
                
            case 'save':
                $obj->saveToDB();
        }
        break;
        
    case 'delete_source':
        if (is_array($_POST['ComplaintID']))
        {
            foreach ($_POST['ComplaintID'] as $complaintID)
            {
                $obj = new Complaint($complaintID);
                $obj->deleteSource();
            }
        }
        break;
}

$employers = User::getUsers(USER_TYPE_EMPLOYER);      

$listing = new Listing();
$listing->onBeforeParseRow = parse_row;
$listing->parse($template, 'select * from complaint c inner join user u on u.UserID = c.UserID');

function parse_row($tpl, $row)
{
	global $employers;
		
	foreach ($employers as $employer)
	{
		$tpl->setVariable('EmployerID', $employer->UserID);
		$tpl->setVariable('EmployerFirstname', $employer->UserFirstname);
		$tpl->setVariable('EmployerLastname', $employer->UserLastname);
		if ($employer->UserID == $row['ToUserID'])
		{
			$tpl->touchBlock('employer_selected');
		}

		$tpl->parse('employer');
	}

	//print_r($row);
	switch ($row['ComplaintSource'])
	{
		case COMPLAINT_SOURCE_PRODUCT:
			$product = new Product($row['ComplaintSourceID']);
            $tpl->setVariable('ProductID',   $product->ProductID);
			$tpl->setVariable('ProductName', $product->ProductName);
			break;
            
            case COMPLAINT_SOURCE_PHOTO:
            $photo = new Photo($row['ComplaintSourceID']);
            $tpl->setVariable('PhotoID',   $photo->PhotoID);
            $tpl->setVariable('PhotoName', $photo->PhotoName);
            break;

            case COMPLAINT_SOURCE_VIDEO:
            $video = new Video($row['ComplaintSourceID']);
            $tpl->setVariable('VideoID',   $video->VideoID);
            $tpl->setVariable('VideoName', $video->VideoName);
            break;
}
	
	switch ($row['ComplaintStatus'])
	{
		case COMPLAINT_STATUS_NEW:
			$tpl->touchBlock('status_new');
			break;
		case COMPLAINT_STATUS_RESOLVED:
			$tpl->touchBlock('status_resolved');
			break;
			
		case COMPLAINT_STATUS_DECLINED:
			$tpl->touchBlock('status_declined');
			break;
	}
}

require_once('includes/admin_bottom.php');
?>