<?
/*
NetworX - open-source social networks platform
Copyright (C) 2009 SocialABC, Inc. http://www.socialabc.com
This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License along with this program in a file called LICENSE; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/ 

$section = 'calendar';
require_once('includes/application_top.php');

if (Session::isCurrentSessionLoggedIn())
{
	$template->setGlobalVariable('SectionHeader', 'Calendar');

	$obj = $user;

	switch ($entity = ucfirst(isset($_GET['entity']) ? $_GET['entity'] : @$_GET['type']))
	{
		case 'User':
		case 'Organization':
		case 'Group':
		case 'Community':

			$obj = Entity::getObject($entity, @$_GET['id']);
	}


	if ($obj->{db_get_entity_key($obj)} != -1)
	{
		if ($obj->checkCalendarPrivacy($user->UserID))
		{
            if ((get_class($obj) == 'User') && ($obj->UserID == $user->UserID))
            {
                if (!UserBlock::checkUserBlockResources(USER_BLOCKED_RESOURCES, USERBLOCK_RESOURCE_INVITATIONS))
                {
                    $template->touchBlock('invite_link');
                    $template->touchBlock('sync_link');
                }

                $template->touchBlock('edit_panel');
            }
            else
            {
                $template->touchBlock('back_link');
            }

			if (isset($_GET['delete']))
			{
				$event = new Event($_GET['delete']);

				if ($event->isAdmin($user->UserID))
				{
					$event->delete();
				}
			}
			$arrEvents = $obj->getEvents();
			$arrEventsByDate = array();

			foreach ($arrEvents as $event)
			{
				$timestamp = strtotime($event->EventStartDate);

				$event_date = date('Y-m-d', $timestamp);
				if (!isset($arrEventsByDate[$event_date]))
				{
					$arrEventsByDate[$event_date] = array();
				}
				$arrEventsByDate[$event_date][] = $event;
			}

			$month = isset($_GET['month']) ? $_GET['month'] : date('m');
			$year  = isset($_GET['year']) ? $_GET['year'] : date('Y');
			$day   = isset($_GET['day']) ? $_GET['day'] : date('d') - date('w');

			$time = mktime(0, 0, 0, $month, $day, $year);

			$next = mktime(0, 0, 0, date('m', $time), date('d', $time) + 7, date('Y', $time));
			$prev = mktime(0, 0, 0, date('m', $time), date('d', $time) - 7, date('Y', $time));

			$template->setVariable('NextMonth', date('m', $next));
			$template->setVariable('NextYear', date('Y', $next));
			$template->setVariable('NextDay', date('d', $next));

			$template->setVariable('PrevMonth', date('m', $prev));
			$template->setVariable('PrevYear', date('Y', $prev));
		    $template->setVariable('PrevDay', date('d', $prev));

			$template->setVariable('Entity', get_class($obj));
			$template->setVariable('EntityID', $obj->{db_get_entity_key($obj)});

		    while ($time < $next)
		    {
	    		$event_date = date('Y-m-d', $time);

	    		if (isset($arrEventsByDate[$event_date]))
	    		{
	    			foreach ($arrEventsByDate[$event_date] as $event)
	    			{
						$template->setVariable('EventID',	 $event->EventID);
						$template->setVariable('EventName',	 $event->EventName);
						$template->setVariable('EventTime',  $event->EventStartDate);
						if ($event->isAdmin($user->UserID))
						{
							$template->touchBlock('event_menu');
						}
						$template->parse('event');
	    			}
				}

	    		$template->setVariable('Date', $event_date);
	    		$template->parse('day');

	    		$time = mktime(0, 0, 0, date('m', $time), date('d', $time) + 1, date('Y', $time));
		    }
		}
	}
}


require_once('includes/application_bottom.php');
?>