<?php
/*
NetworX - open-source social networks platform
Copyright (C) 2009 SocialABC, Inc. http://www.socialabc.com
This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License along with this program in a file called LICENSE; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/ 

require_once('includes/application_top.php');

if (!Session::isCurrentSessionLoggedIn())
{
	cmn_unauthorized_action();
}

// Make sure program execution doesn't time out
set_time_limit(0);

if (!isset($_GET['id']) || empty($_GET['id']))
{
	cmn_unauthorized_action();
}

$shared_file = new SharedFile($_GET['id']);

if (!$shared_file->checkUserPermissions($user->UserID))
{
	cmn_unauthorized_action();
}

// Get real file name.
$fname = $shared_file->SharedFileID;

// get full file path (including subfolders)
$file_path = '';
find_file(PATH_DOWNLOAD_FILES, $fname, $file_path);

if (!is_file($file_path))
{
	die("File does not exist.");
}

// file size in bytes
$fsize = filesize($file_path);

// file extension
$fext = $shared_file->FileMIMEType;

// get mime type
if ($FILE_DOWNLOAD_ALLOWED_EXT[$fext] == '')
{
	$mtype = '';
  	// mime type is not set, get from server settings
  	if (function_exists('mime_content_type'))
  	{
    	$mtype = mime_content_type($file_path);
  	}
  	else if (function_exists('finfo_file'))
  	{
    	$finfo = finfo_open(FILEINFO_MIME); // return mime type
    	$mtype = finfo_file($finfo, $file_path);
    	finfo_close($finfo);
    }
  	if ($mtype == '')
  	{
    	$mtype = "application/force-download";
    }
}
else
{
	// get defined mime type
  	$mtype = $FILE_DOWNLOAD_ALLOWED_EXT[$fext];
}

// Browser will try to save file with this filename
$asfname = $shared_file->FileName;

ob_start();

// set headers
header("Content-Description: File Transfer");
header("Content-Type: " . $mtype);

if (isset($_SERVER['HTTP_USER_AGENT']) && (strpos($_SERVER['HTTP_USER_AGENT'], 'MSIE') !== false)) {
    header('Content-Disposition: inline; filename="' . $asfname . '"');
    header('Expires: 0');
    header('Cache-Control: must-revalidate, post-check=0, pre-check=0');
    //header("Cache-Control: public, must-revalidate");
    header('Pragma: public');
} else {
    header('Content-Disposition: attachment; filename="' . $asfname . '"');
    header('Expires: 0');
    header('Pragma: no-cache');
}

header("Content-Transfer-Encoding: binary");
header("Content-Length: " . $fsize);

/*
header("Pragma: public");
header("Expires: 0");
header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
//header("Cache-Control: public");
header("Cache-Control: private",false);
header("Content-Description: File Transfer");
header("Content-Type: " . $mtype);
header("Content-Disposition: attachment; filename=". $asfname);
header("Content-Transfer-Encoding: binary");
header("Content-Length: " . $fsize);
*/

ob_end_clean();

// download
$file = @fopen($file_path,"rb");

if ($file)
{
	while(!feof($file))
	{
    	print(fread($file, 1024*8));
    	flush();
    	if (connection_status() != 0)
    	{
    		@fclose($file);
    		die();
    	}
  	}
  	@fclose($file);
}