<?php
/*
NetworX - open-source social networks platform
Copyright (C) 2009 SocialABC, Inc. http://www.socialabc.com
This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License along with this program in a file called LICENSE; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/ 

$section = 'calendar';
require_once('includes/application_top.php');

if (!Session::isCurrentSessionLoggedIn())
{
	cmn_unauthorized_action();
}

$event = new Event($_GET['id']);

if ($event->EventID != -1)
{
	if ($event->isAdmin($user->UserID))
	{
		if (!UserBlock::checkUserBlockResources(USER_BLOCKED_RESOURCES, USERBLOCK_RESOURCE_INVITATIONS))
		{
		    $template->touchBlock('event_invite');
		}

		if (isset($_POST['submited']))
		{
			$toInvite = array();
			if (is_array($_POST['UserID']))
			{
			    foreach ($_POST['UserID'] as $userID)
			    {
			        $member = new User($userID);
			        if ($member->UserID != -1)
			        {
			            $toInvite[$member->UserID] = $member;
			        }
			    }
			}

			if (is_array($_POST['GroupID']))
			{
				foreach ($_POST['GroupID'] as $groupID)
				{
					$group = new Group($groupID);
					if ($group->GroupID != -1)
					{
						$members = $group->getGroupMembers();
						foreach ($members as $member)
						{
							$toInvite[$member->UserID] = $member;
						}
					}
				}
			}
			if (is_array($_POST['OrganizationID']))
			{
				foreach ($_POST['OrganizationID'] as $orgID)
				{
					$org = new Organization($orgID);
					if ($org->OrganizationID != -1)
					{
						$members = $org->getOrganizationMembers();
						foreach ($members as $member)
						{
							$toInvite[$member->UserID] = $member;
						}
					}
				}
			}
			if (is_array($_POST['CommunityID']))
			{
				foreach ($_POST['CommunityID'] as $comID)
				{
					$com = new Community($comID);
					if ($com->CommunityID != -1)
					{
						$members = $com->getCommunityMembers();
						foreach ($members as $member)
						{
							$toInvite[$member->UserID] = $member;
						}
					}
				}
			}

			foreach ($toInvite as $member)
			{
				if (!$event->isSubscribed($member->UserID))
				{
					if (!Message::isEventInviteSent($member->UserID, $event->EventID))
					{
						$user->sendEventInvite($member->UserID, $event->EventID, @$_POST['txtMessage']);
					}
				}
			}
		}

		if (isset($_GET['admin']))
		{
		    if ($event->isAdmin($_GET['admin']))
		    {
		        $event->removeAdmin($_GET['admin']);
		    }
		    else
		    {
		        $event->makeAdmin($_GET['admin']);
		    }
		}

		$query = 'select u.UserID as ID, concat_ws(\' \', u.UserFirstname, u.UserLastname) as Name, \'User\' as Entity, \'Accepted\' as Status, if(EventToParticipantStatus = %d, 2, 1) as Admin from eventtoparticipant p inner join user u on u.UserID = p.UserID where EventID = %d union select if(MessageType in (%d,%d), mr.UserID, ms.UserID) as ID, if(MessageType in (%d,%d), concat_ws(\' \', mr.UserFirstname, mr.UserLastname), concat_ws(\' \', ms.UserFirstname, ms.UserLastname)) as Name, \'User\' as Entity, if(MessageType in (%d,%d), \'Pending\', \'Rejected\') as Status, 0 as Admin from message m inner join user ms on ms.UserID = m.UserID inner join user mr on mr.UserID = m.use_UserID where MessageType in(%d,%d,%d,%d) group by ID';
		$params = array(USER_EVENT_ADMIN, $event->EventID, MESSAGE_EVENT_INVITE, MESSAGE_EVENT_INVITE_DECLINED, MESSAGE_EVENT_INVITE, MESSAGE_EVENT_INVITE_DECLINED, MESSAGE_EVENT_INVITE, MESSAGE_EVENT_REQUEST, MESSAGE_EVENT_INVITE_DECLINED, MESSAGE_EVENT_INVITE, MESSAGE_EVENT_REQUEST, MESSAGE_EVENT_REQUEST_DECLINED);

		$select = 'none';
		$query .= ' order by ';
		switch (@$_GET['select'])
		{
		    case 'pending':
		    case 'accepted':
		    	$query .= 'if(Status = %s, 1, 0)';
		    	$params[] = ucfirst($_GET['select']);
		    	$select = $_GET['select'];
		    	break;

		    case 'all':
		    	$select = 'all';

		    default:
		    	$query .= '1';
		}

		$template->touchBlock('select_' . $select);
		$template->setGlobalVariable('Select', $select);
		$template->setGlobalVariable('EventID', $event->EventID);

		$sortField = isset($_GET['sort']) ? $_GET['sort'] : 'Name';
		$sortOrder = 'desc';

		foreach (array('Name', 'Status') as $field)
		{
			if ($field == $sortField)
			{
				switch(@$_GET['order'])
				{
					case 'asc':
					case 'desc':

						$sortOrder = $_GET['order'];
				}

				$template->setGlobalVariable($sortField . 'SortOrder', $sortOrder == 'desc' ? 'asc' : 'desc');
				$template->setGlobalVariable('icon_' . $sortField, 'triangle_r_' . ($sortOrder == 'desc' ? 'down' : 'up') . '.gif');

				$query .= ', ' . $field . ' ' . $sortOrder;
			}
			else
			{
				$template->setGlobalVariable('icon_' . $field, 'triangle_g_down.gif');
				$template->setGlobalVariable($field . 'SortOrder', 'desc');
			}
		}

		$listing = new Listing();
		$listing->onBeforeParseRow = parse_guest;
		$listing->parse($template, $query, $params);


		$connections = new MyConnections('CONNECTIONS', 'control.myconnections_select.html');
		$connections->parse($template, $user->UserID, 0);

	}
	else
	{
	    cmn_redirect('event.php?event_id=' . $event->EventID);
	}
}
else
{
    cmn_unauthorized_action();
}

function parse_guest($tpl, $row)
{
	global $select;

	if (strtolower($row['Status']) == $select || $select == 'all')
	{
		$tpl->touchBlock('checked');
	}

	switch ($row['Admin'])
	{
		case 1:
			$tpl->touchBlock('make_admin');
			break;

		case 2:
			$tpl->touchBlock('remove_admin');
	}
}

require_once('includes/application_bottom.php');