<?php
/*
NetworX - open-source social networks platform
Copyright (C) 2009 SocialABC, Inc. http://www.socialabc.com
This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License along with this program in a file called LICENSE; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/ 

require_once('includes/application_top.php');

$dateregexp="#([0-9]{4})/([0-9]{2})/([0-9]{2}) ([0-9]{2}):([0-9]{2}) [P|A]M#i";
$startdatecorrect=true;
$enddatecorrect=true;
	
if (!Session::isCurrentSessionLoggedIn())
{
	cmn_unauthorized_action();
}

$event = new Event(@$_GET['id']);

if ($event->UserID == -1)
{
	$event->UserID = $user->UserID;
	$event->EventAvailability = EVENT_AVAILABILITY_PRIVATE;

	if(isset($_GET["group_id"]) && intval($_GET["group_id"])>0) 
	{
		$event->EventType=EVENT_TYPE_GROUP;
		$event->groupID=$_GET["group_id"];
	}
	if(isset($_GET["user_id"]) && intval($_GET["user_id"])>0) 
	{
		$event->EventType=EVENT_TYPE_PERSONAL;
	}
}
if ($event->UserID == $user->UserID)
{
	foreach (array('Group', 'Organization', 'Community') as $entity)
	{
		$arg = strtolower($entity) . '_id';

		if (isset($_GET[$arg]))
		{
			$event->{$entity . 'ID'} = $_GET[$arg];
			break;
		}
	}

    $data = array
    (
        'EventName'         => $event->EventName,
        'EventDescription'  => $event->EventDescription,
        'EventCost'	    => $event->EventCost,
        'EventStartDate'    => $event->EventStartDate,
        'EventEndDate'      => $event->EventEndDate
    );

    $data['EventType'] = $event->EventType;
    $data['EventSubType'] = $event->EventSubType;

    if (isset($_GET['type']))
    {
        switch ($_GET['type'])
        {
            case EVENT_TYPE_GROUP:
            case EVENT_TYPE_FREE:
            case EVENT_TYPE_PERSONAL:
                $data['EventType'] = $_GET['type'];

        }
    }

    if ($data['EventType'] == EVENT_TYPE_GROUP)
    {
        $data = array_merge($data,
            array
            (
                'EventAvailability'     => $event->EventAvailability,
                'EventCost'             => $event->EventCost,
                'EventLocationName'     => $event->EventLocationName,
                'EventLocationStreet'   => $event->EventLocationStreet,
                'EventLocationCountry'  => $event->EventLocationCountry,
                'EventLocationState'    => $event->EventLocationState,
                'EventLocationCity'     => $event->EventLocationCity,
                'EventLocationZip'      => $event->EventLocationZip,
                'EventContactPhone'     => $event->EventContactPhone,
                'EventContactEmail'     => $event->EventContactEmail
            )
        );
        $template->touchBlock('event_subtype');
    }
    else if ($data['EventType'] == EVENT_TYPE_PERSONAL)
    {
        $data = array_merge($data,
            array
            (
                'EventAvailability' => $event->EventAvailability,
                'EventReminder'     => $event->EventReminder,
                'EventReminderType' => $event->EventReminderType
            )
        );
        $template->touchBlock('event_subtype');
    }
    else if ($data['EventType'] == EVENT_TYPE_FREE)
    {
    	$template->hideBlock('event_name');
    	$template->hideBlock('event_description');
    }
	if (isset($_POST['action']))
	{
        $error = false;
		foreach ($data as $field => $value)
		{
            $data[$field] = $_POST[$field];

            switch ($field)
            {
                case 'EventReminderType':
                    if (is_array($data[$field]))
                    {
                        $masks = $data[$field];
                        $data['EventReminderType'] = 0;
                        foreach ($masks as $mask)
                        {
                            $data['EventReminderType'] |= $mask;
                        }
                    }
                    break;
                case 'EventCost':
                	if($data[$field]!="" && !preg_match("#^[0-9]*[\\.]*[0-9]*\$#", $data[$field]))
                	{
                		$template->touchBlock($field.'_incorrect');
                		$error = true;
                	} 
                	else 
                	{
                		$data[$field]=floatval($data[$field]);
			}
                	break;
                case 'EventName':
                case 'EventDescription':
                case 'EventStartDate':
                case 'EventLocationName':
                    if (empty($data[$field]) && $_POST['action'] == 'save' && $data['EventType'] != EVENT_TYPE_FREE)
                    {
                        $template->touchBlock($field . '_empty');
                        $error = true;
                    }
                    if($field=="EventStartDate" && $data[$field]!="" && !preg_match($dateregexp, $data[$field])) 
                    {
                    	$template->touchBlock($field . '_incorrect');
                    	$error = true;
                    	$startdatecorrect=false;
                    }
                    break;
               case 'EventEndDate':
               	    if($data[$field]!="" && !preg_match($dateregexp, $data[$field]))
               	    {
               	    	$template->touchBlock($field . '_incorrect');
               	    	$enddatecorrect=false;
               	    	$error = true;
               	    }
	            break;
            }
		}
		if (!$error && $_POST['action'] == 'save')
		{
            $event->populateFromArray($data);
			if($startdatecorrect)
			{
				$startTime = strtotime($event->EventStartDate);
				$event->EventStartDate	= date('Y-m-d H:i:s', $startTime);
			}
			if($enddatecorrect)
			{
				$endTime = empty($event->EventEndDate) ? $startTime : strtotime($event->EventEndDate);
                                $event->EventEndDate	= date('Y-m-d H:i:s', $endTime);
                        }

			if ($startdatecorrect && $enddatecorrect && $startTime <= $endTime)
			{
                $event->EventName = preg_replace_callback("|(\w{10,})|", 'cmn_split_text_10', $event->EventName);
				$event->saveToDB();

				cmn_create_path((PATH_EVENT_PICS . $event->EventID), false);
				for ($i = 1; $i <= 4; $i++)
				{
					if (is_uploaded_file($_FILES['EventPicture' . $i]['tmp_name']))
					{
						$event->{'EventPicture' . $i} = $_FILES['EventPicture' . $i]['name'];

						$uploaded_file = PATH_EVENT_PICS . $event->{'EventPicture' . $i};
						move_uploaded_file($_FILES['EventPicture' . $i]['tmp_name'], $uploaded_file);

						$photopath = PATH_EVENT_PICS . $event->EventID;
						$thumb = new Thumbnail($uploaded_file);

						$thumb->setNewFilename($event->{'EventPicture' . $i});

						$thumb->setSavePath($photopath);
						$thumb->setDimension(EVENT_PHOTO_WIDTH, EVENT_PHOTO_HEIGHT);
						try
						{
							$thumb->resize();
						}
						catch (Exception $ex)
						{
							$event->{'EventPicture' . $i} = '';
						}

						unlink($uploaded_file);
					}
				}
				$event->saveToDB();
				$event->addParticipant($event->UserID);

                $owner = $event->getOwner();

				cmn_redirect('calendar.php?entity=' . get_class($owner) . '&id=' . $owner->{db_get_entity_key($owner)});
			}
			else
			{
				$template->touchBlock('incorrect_dates');
			}
		}
	}


	if($startdatecorrect) 
	{
		$data['EventStartDate'] = !empty($data['EventStartDate']) ? date('Y/m/d h:i A', strtotime($data['EventStartDate'])) : '';
	}
	if($enddatecorrect)
	{
		$data['EventEndDate']   = !empty($data['EventEndDate']) ? date('Y/m/d h:i A', strtotime($data['EventEndDate'])) : '';
	}
	if($data['EventStartDate'] == $data['EventEndDate']) 
	{
		$data['EventEndDate']="";
	}

    $template->setVariable($data);
    $template->setVariable($data['EventSubType'] . '_selected', 'selected');
    
    if (count($user->getConnectedGroups()) > 0)
    	$template->touchBlock('group_event');

	if (isset($data['EventLocationCountry']))
    {
	    foreach ($COUNTRIES as $key => $value)
		{
			$template->setVariable('key', $key);
			$template->setVariable('value', $value);
            if ($key == $data['EventLocationCountry'])
            {
                $template->setVariable('selected', 'selected');
            }
            $template->parse('event_location_country');
		}

		foreach($STATES as $key => $value )
		{
			$template->setVariable('key', $key);
			$template->setVariable('value', $value);
            if ($key == $data['EventLocationState'])
            {
                $template->setVariable('selected', 'selected');
            }
            $template->parse('event_location_state');
		}

        /*
		$countries = Country::getAll();
        $countrySelected = new Country();
        foreach ($countries as $country)
        {
            $template->setVariable('ID', $country->CountryID);
            $template->setVariable('Value', $country->CountryName);
            if ($country->CountryID == $data['EventLocationCountry'])
            {
                $template->setVariable('selected', 'selected');
                $countrySelected = $country;
            }
            $template->parse('event_location_country');
        }

        $states = $countrySelected->getStates();
        foreach ($states as $state)
        {
            $template->setVariable('ID', $state->StateID);
            $template->setVariable('Value', $state->StateName);
            if ($state->StateID == $data['EventLocationState'])
            {
                $template->setVariable('selected', 'selected');
            }
            $template->parse('event_location_state');
        }
        */
    }
}

require_once('includes/application_bottom.php');