<?php
/*
NetworX - open-source social networks platform
Copyright (C) 2009 SocialABC, Inc. http://www.socialabc.com
This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License along with this program in a file called LICENSE; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/ 

$section = 'files';
include('includes/application_top.php');

if (!Session::isCurrentSessionLoggedIn())
{
	cmn_unauthorized_action();
}

if (UserBlock::checkUserBlockResources(USER_BLOCKED_RESOURCES, USERBLOCK_RESOURCE_MEDIA))
{
    cmn_unathorized_action();
}

$template->loadTemplateFile('file_add.html');

$ownertype = isset($_GET['owner_type']) ? $_GET['owner_type'] : ( isset($_POST['owner_type']) ? $_POST['owner_type'] : 'user');
$ownerid = isset($_GET['owner_id']) ? $_GET['owner_id'] : ( isset($_POST['owner_id']) ? $_POST['owner_id'] : 'owner_id');
if ($ownertype != 'user')
{
    $template->setVariable('Entity', $ownertype);
    $template->setVariable('EntityID', $ownerid);
    $template->parse('back_link');
}
$file = new File(-1);
$file->setOwner($ownertype, $ownerid);
if (! $file->userCanCreateSuch($user->UserID) )
{
    cmn_unathorized_action();
}
if (! $file->userCanEdit($user->UserID))
{
    cmn_unathorized_action();
}

if ($_POST['action'] == 'upload')
{
    $files = array();
    foreach ($_FILES['FileFile']['tmp_name'] as $index => $tmp_file)
    {
        if (is_uploaded_file($tmp_file))
        {
            if (!in_array($_FILES['FileFile']['type'][$index], array()))
            {
                //continue;
            }
            $pathinfo = pathinfo($_FILES['FileFile']['name'][$index]);

            $file = new File(-1);
            $file->FilePath = $pathinfo['basename'];
            $file->setOwner($ownertype, $ownerid);
            $file->saveToDB();

            $filepath = PATH_FILES . "/" . $ownerid . "/";
            cmn_create_path($filepath, false);
            move_uploaded_file($tmp_file, $filepath . $file->FilePath);
            //move_uploaded_file($_FILES['photofile']['tmp_name'], PATH_ALBUM_PICS . $video->AlbumID . "/" . $photo->PhotoID);
            //cmn_redirect("video_edit.php?video_id=" . $video->VideoID);
            $files[] = $file;
        }
    }
    foreach ($files as $file)
    {
         $template->setVariable('FileID',        $file->FileID);
         $template->setVariable('FileName',      $file->FileName);
         $template->setVariable('FileIconURL',   $file->getIconURL());
         $template->parse('file_line');
    }
    $template->touchBlock('file_form');
}
elseif ($_POST['action'] == 'save')
{
    foreach ($_POST['FileName'] as $id => $name)
    {
        $file = new File($id);
        if (!$file->userCanEdit($user->UserID))
        {
            //cmn_unathorized_action();
        }
        if (isset($_POST['delfile'][$id]))
        {
            $file->delete();
            continue;
        }

        $file->FileName = $name;
        $file->saveToDB();
    }
    //cmn_redirect('files.php?owner_type=' . $ownertype . '&owner_id=' . $ownerid);
    $template->touchBlock('successfull');
}
else
{
    $template->touchBlock('upload_form');
}

include('includes/application_bottom.php');