<?php
/*
NetworX - open-source social networks platform
Copyright (C) 2009 SocialABC, Inc. http://www.socialabc.com
This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License along with this program in a file called LICENSE; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/ 

require_once('includes/application_top.php');

if (!Session::isCurrentSessionLoggedIn())
{
	cmn_unauthorized_action();
}

$form_id = isset($_GET['form_id']) ? $_GET['form_id'] : ( isset($_POST['FormID']) ? $_POST['FormID'] : -1 );
$form = new Form($form_id);

$object = $form->getOwner();
$entity = ucfirst(get_class($object));
$id = $object->{db_get_entity_key($object)};

if ( ($id == -1) || (!$object->hasMember($user->UserID)) )
{
	cmn_unauthorized_action();
}

$form_submissions = FormSubmission::getFormSubmissions($form_id);

if ($_POST['action'] == 'download')
{
	$pdf= new FPDF();

	$pdf->SetAuthor($user->UserFirstname . ' ' . $user->UserLastname);
	$pdf->SetTitle($form->FormName);

    $pdf->SetFont('Helvetica','B',20);
	$pdf->SetTextColor(50,60,100);

	$pdf->AddPage('P');
	$pdf->SetDisplayMode('real','default');

    $pdf->SetXY(50,20);
	$pdf->SetDrawColor(50,60,100);
	$pdf->Cell(100, 10, $form->FormName . ' Submissions', 0, 0, 'C', 0);

    $y = 50;
	foreach ($form_submissions as $submission)
	{
		$pdf->SetXY(10, $y);
		$pdf->SetFontSize(15);

	    $submission_user = new User($submission->UserID);
	    $pdf->Write(5, $submission_user->UserFirstname . $submission_user->UserLastname);
	    $pdf->Write(5, ' (' . date("F j, Y, g:i a", strtotime($submission->FormSubmissionDate)) . ')');

	    $y += 10;

        $pdf->SetFontSize(10);
	    $form_submission_fields = FormSubmission::getSubmittedFormFields($submission->FormID, $submission->UserID);
	    foreach ($form_submission_fields as $field)
	    {
	        $form_field = new FormField($field->FormFieldID);

            $pdf->SetXY(10,$y);
			$pdf->Write(5, $form_field->FormFieldName . ': ');

	        if ($form_field->FormFieldType == FORM_FIELD_TYPE_MULTIPLE)
	        {
	            $form_field_option = new FormFieldOption($field->FormFieldOptionID);
        		$pdf->Write(5, $form_field_option->FormFieldOptionValue);
			}
			else
			{
	    		$pdf->Write(5, $field->FormFieldValue);
			}
		    $y += 5;
		}
		$y += 5;
	}

	$pdf->Output('form' . $form->FormID . '.pdf','I');
}

foreach ($form_submissions as $submission)
{
    $form_submission_fields = FormSubmission::getSubmittedFormFields($submission->FormID, $submission->UserID);
    foreach ($form_submission_fields as $field)
    {
        $form_field = new FormField($field->FormFieldID);
        $template->setVariable('FormFieldName', $form_field->FormFieldName);
        if ($form_field->FormFieldType == FORM_FIELD_TYPE_MULTIPLE)
        {
            $form_field_option = new FormFieldOption($field->FormFieldOptionID);
        	$template->setVariable('FormFieldValue', $form_field_option->FormFieldOptionValue);
		}
		else
		{
	    	$template->setVariable('FormFieldValue', $field->FormFieldValue);
		}
	    $template->parse('form_field');
	}

    $submission_user = new User($submission->UserID);
    $template->setVariable('UserID', $submission_user->UserID);
    $template->setVariable('UserFirstname', $submission_user->UserFirstname);
    $template->setVariable('UserLastname', $submission_user->UserLastname);
    $template->setVariable('FormSubmissionDate', date("F j, Y, g:i a", strtotime($submission->FormSubmissionDate)));
    $template->parse('form_submission');
}

$template->setVariable('FormID', $form_id);

require_once('includes/application_bottom.php');