<?php
/*
NetworX - open-source social networks platform
Copyright (C) 2009 SocialABC, Inc. http://www.socialabc.com
This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License along with this program in a file called LICENSE; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/ 

require_once('includes/application_top.php');

if (Session::isCurrentSessionLoggedIn())
{
    if (UserBlock::checkUserBlockResources(USER_BLOCKED_RESOURCES, USERBLOCK_RESOURCE_INVITATIONS))
    {
        cmn_unathorized_action();
    }
	$template->setGlobalVariable('SectionHeader', 'Send Invitation');

	$selected = new Group(@$_GET['id']);
	$groups   = $user->getGroups(true);

	foreach ($groups as $group)
	{
		$template->setVariable('GroupID',	$group->GroupID);
		$template->setVariable('GroupName',	$group->GroupName);

		if ($group->GroupID == $selected->GroupID)
		{
			$template->touchBlock('group_selected');
		}
		$template->parse('group');
	}

	if (isset($_POST['connections']))
	{
		if (is_array(@$_POST['UserID']))
		{
			foreach ($_POST['UserID'] as $userID)
			{
				$template->setVariable('UserID', $userID);
				$template->parse('connection');
			}
		}
		else
		{
			$template->touchBlock('error_not_selected');
			$template->hideBlock('form');
		}
	}
	else
	{
		$buddylist = new BuddyList($template, 'buddylist', $user->UserID, 'My World');
	}
	if (isset($_POST['submited']))
	{
		$group = new Group(@$_POST['InviteGroupID']);
		if ($group->userIsAdmin($user->UserID))
		{
			$members = BuddyList::getUsersFromPost();

			foreach ($members as $member)
			{
				$group->inviteMember($user->UserID, $member->UserID, @$_POST['txtMessageText']);
			}
		}
		cmn_redirect(cmn_get_profile_link('Group', $group->GroupID));
	}
}
else
{
	cmn_unauthorized_action();
}

require_once('includes/application_bottom.php');
?>