<?php
/*
NetworX - open-source social networks platform
Copyright (C) 2009 SocialABC, Inc. http://www.socialabc.com
This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License along with this program in a file called LICENSE; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/ 

include('includes/application_top.php');
if ($user->isAuthorised())
{
    
	$group = new Group(@$_GET['group_id']);

	if ($group->GroupID != -1)
	{
		$template->setGlobalVariable('_GroupID', $group->GroupID);
		if ($group->userIsAdmin($user->UserID))
		{	
            if (!UserBlock::checkUserBlockResources(USER_BLOCKED_RESOURCES, USERBLOCK_RESOURCE_INVITATIONS))
            {
                $template->touchBlock('invite_link');
                $template->touchBlock('admin_invite_link');
            }
            
			switch (@$_POST['submited'])
			{                   
				case 'change_status':
				    $member = new User(@$_POST['UserID']);
				    
				    if ($member->UserID != -1)
				    {
						$connections = Connection::getConnections(array(
							'UserID' => $member->UserID, 
							'GroupID' => $group->GroupID, 
							'ConnectionType' => array(CONNECTIONTYPE_ADMIN, CONNECTIONTYPE_OWNER, CONNECTIONTYPE_MEMBER)));
						
						foreach ($connections as $connection)
						{
							switch (@$_POST['Status'])
							{
                                case CONNECTIONFLAG_STATUS_DELETED:
                                    $connection->delete();
                                    break;
                                    
								case CONNECTIONFLAG_STATUS_ACTIVE:
								case CONNECTIONFLAG_STATUS_SUSPEND:
								case CONNECTIONFLAG_STATUS_REINSTATED:
								
									$connection->Flags = $_POST['Status'];
									$connection->saveToDB();
							}
						}				
					}
					break;
					
				case 'admin_invite':
					if (is_array(@$_POST['UserID']))
					{
						foreach ($_POST['UserID'] as $userID)
						{
							if (!$group->userIsAdmin($userID))
							{
								Message::sendGroupAdminInvite($user->UserID, $userID, $group->GroupID);
							}
						}
					}
					break;
				
				case 'create_group':
					if (is_array(@$_POST['UserID']))
					{
						$_SESSION['connect_group_users'] = array('UserID' => ud_sanitize($_POST['UserID']), 'GroupID' => $group->GroupID);
					}
					cmn_redirect('group_register.php');
					break;
			}
			
			if (isset($_GET['delete_admin']))
			{
    			$connections = Connection::getConnections(array('GroupID' => $group->GroupID, 
    				'UserID' => intval($_GET['delete_admin']), 'ConnectionType' => CONNECTIONTYPE_ADMIN));
    			foreach ($connections as $connection)
    			{
    				$connection->ConnectionType = CONNECTIONTYPE_MEMBER;
    				$connection->saveToDB();
    			}
			}	
            $sortField = isset($_GET['sort']) ? $_GET['sort'] : 'UserFirstname';
            $sortOrder = 'desc';

			$listing = new Listing();
			$listing->Limit = 100;
			$listing->onBeforeParseRow = parse_member;
			$query = 'select * from (SELECT u.*, c.Flags ' . (count($addQuery) ? ',' . join(',', $addQuery) : '') . 
                ' FROM `connection` c inner join user u on c.UserID = u.UserID ' . 
				'where c.GroupID = %d and c.ConnectionType in (%d, %d, %d)' . 
                ' union select iu.*, -1 as Flags ' . 
                ' from sentinvitation si inner join user iu on si.UserID = iu.UserID and GroupID = ' . $group->GroupID . 
                ' union select mu.*, -1 as Flags ' . 
                ' from message m inner join user mu on m.use_UserID = mu.UserID and MessageType = ' . MESSAGE_GROUP_INVITE . 
                ' and ObjectID = ' . $group->GroupID . 
                ' union select mmu.*, -1 as Flags ' .
                ' from message mm inner join user mmu on mmu.UserID = mm.UserID and MessageType = ' . MESSAGE_GROUP_REQUEST . 
                ' and ObjectID = ' . $group->GroupID . ') as tmp group by UserID ' . $orderByPoints;
				
			foreach (array('UserFirstname', 'UserLastname', 'Flags') as $field)
			{
				if ($field == $sortField)
				{
					switch(@$_GET['order'])
					{
						case 'asc':
						case 'desc':
						
							$sortOrder = $_GET['order'];
					}
					
					$template->setGlobalVariable($sortField . 'SortOrder', $sortOrder == 'desc' ? 'asc' : 'desc');
					$template->setGlobalVariable('icon_' . $sortField, 'triangle_r_' . ($sortOrder == 'desc' ? 'down' : 'up') . '.gif');
					
					
					$query .= ' order by ' . $field . ' ' . $sortOrder;
				}
				else
				{
					$template->setGlobalVariable('icon_' . $field, 'triangle_g_down.gif');
					$template->setGlobalVariable($field . 'SortOrder', 'desc');
				}
			}
			
			$template->setGlobalVariable('GroupID', $group->GroupID);
			$template->setGlobalVariable('GroupName', $group->GroupName);
			
			$listing->parse($template, $query, $group->GroupID, CONNECTIONTYPE_OWNER, CONNECTIONTYPE_MEMBER, CONNECTIONTYPE_ADMIN);
			
			$members = $group->getGroupMembers();
			$template->setGlobalVariable('MembersCount', count($members));
			
			$xls_data = array();

			foreach ($members as $member)
			{
				$member_id = $member->UserID;
				$member_email = $member->UserEmail;
				
				$xls_data[$member_id] = array(
					$EXCEL_MEMBER_SHEET_COLUMN_NAMES['MEMBER_EMAIL'] => $member_email,
					$EXCEL_MEMBER_SHEET_COLUMN_NAMES['MEMBER_FIRST_NAME'] => $member->UserFirstname,
                    $EXCEL_MEMBER_SHEET_COLUMN_NAMES['MEMBER_LAST_NAME'] => $member->UserLastname,
				);
			}

			$export_file = 'data/grp' . md5($group->GroupID) . '.xls';
			$fp = fopen('xlsfile://./usr/local/apache/htdocs/cc/' . $export_file, "wb");

			fwrite($fp, serialize($xls_data));
			fclose($fp);

			$template->setVariable('excel_sheet_filepath', $export_file);

		}
		else
		{
			cmn_unathorized_action();
		}
	}
}

function parse_member($template, $row)
{
	global $group, $user, $categories;
	
	if ($user->UserID != $row['UserID'])
	{
	    if ($group->userIsAdmin($row['UserID'], false))
	    {
	        $template->touchBlock("user_isadmin");
	    }
	}
	
    if ($row['Flags'] == -1)
    {
        $template->touchBlock("pending");
    }
    else
    {
        $template->setVariable('UserID', $row['UserID']);  
        switch ($row['Flags'])
        {
            case CONNECTIONFLAG_STATUS_ACTIVE:
                $template->touchBlock("indstatus_active");
                break;
                
            case CONNECTIONFLAG_STATUS_DELETED:
                $template->touchBlock("indstatus_deleted");
                break;
                
            case CONNECTIONFLAG_STATUS_REINSTATED:
                $template->touchBlock("indstatus_reinstated");
                break;
                
            case CONNECTIONFLAG_STATUS_SUSPEND:
                $template->touchBlock("indstatus_suspend");
                break;
        }
        $template->parse('status');
    }
    $template->setVariable('UserID', $row['UserID']);  
}

include('includes/application_bottom.php');
?>