<?php
/*
NetworX - open-source social networks platform
Copyright (C) 2009 SocialABC, Inc. http://www.socialabc.com
This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License along with this program in a file called LICENSE; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/ 

require_once('includes/application_top.php');

if (!Session::isCurrentSessionLoggedIn())
{
	cmn_unauthorized_action();
}

$group_id = isset($_GET['group_id']) ? $_GET['group_id'] : ( isset($_POST['GroupID']) ? $_POST['GroupID'] : -1 );
$group = new Group($group_id);
$edit_privacy = false;
if ($group->checkViewNewsPrivacy())
{
    if ($_GET['action'] == 'revert')
    {
    	$news_id = $_GET['news_id'];
    	$version_id = $_GET['version_id'];

    	$news = new News($news_id);
    	$news->revertToPreviousVersion($version_id);
	}
    elseif ($_GET['action'] == 'delete')
	{
        $news_id = $_GET['news_id'];
		$group->deleteNews($news_id);
	}

	$allnews = $group->getGroupNews();
	$edit_privacy = $group->checkEditNewsPrivacy();

    if (count($allnews) > 0)
    {
		foreach ($allnews as $news)
		{						
            $latest_news = $news->getLatestNews();      			
            if (!$edit_privacy || (!$group->userIsAdmin($user->UserID) && $user->UserID != $news->UserID))
            {
                $template->hideBlock('edit_privacy_block');
            }    
            else
            {
                if (count($latest_news) > 0)
                {
                    $template->touchBlock('latest_news_link');
                }            
                
                $template->touchBlock('edit_privacy_block');
            }        
			$template->setVariable("NewsID", $news->NewsID);
			$template->setVariable("NewsName", $news->NewsName);
			$template->setVariable("NewsText", $news->NewsText);
			$template->setVariable('TAG_TYPE_NEWS', TAG_TYPE_NEWS);
			                       
			$template->parse('news');
		}
	}
	else
	{
		$template->hideBlock('news');
	}
    $template->setGlobalVariable('GroupID', $group_id);
    if ($group->userIsAdmin($user->UserID))
    {
        $template->touchBlock('settings');
        $template->touchBlock('privacy_settings');
    }
    if ($group->hasMember($user->UserID) && $edit_privacy >= NEWS_PRIVACY_MEMBERS)
    {
        $template->touchBlock('create_news');
    }
    $template->setVariable('Entity', 'group');
    $template->setVariable('EntityID',   $group_id);
    $template->parse('back_link');
}
else
{
    cmn_unauthorized_action();
}

require_once('includes/application_bottom.php');