<?php
/*
NetworX - open-source social networks platform
Copyright (C) 2009 SocialABC, Inc. http://www.socialabc.com
This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License along with this program in a file called LICENSE; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/ 

class Thumbnail
{
	public $OriginalImage;
	public $Filename;

	private $Extension;
	private $Width;
	private $Height;
	private $SavePath;

	public function __construct($img)
	{
		if ((empty($img)) || (!file_exists($img)))
		{
			throw new Exception("Image not found:" . $img);
	 	}
	 	else
	 	{
    		$fileInfo = pathinfo($img);

	  		$this->OriginalImage = $img;
	  		$this->Filename = $fileInfo['basename'];
	  		$this->Extension = strtolower($fileInfo['extension']);
	 	}
	}

	function setSavePath($path)
	{
        cmn_create_path($path, false);
		$this->SavePath = $path;
	}

	function setNewFilename($newName)
	{
		$fileInfo = pathinfo($newName);
		$this->Filename		= $newName;
		$this->Extension	= strtolower($fileInfo['extension']);

	}

	function setDimension($width, $height = '*')
	{
 		$this->Width = $width;
 		$this->Height = $height;
	}

	function copy()
	{
		return move_uploaded_file($this->OriginalImage, $this->SavePath . '/' . $this->Filename);
	}

	function resize()
	{
 		if ((empty($this->Width)) || (empty($this->Height)))
 		{
 			throw new Exception("Enter the width and height");
 		}
 		else
 		{
 			$imgSize = getimagesize($this->OriginalImage);

 			$width = $imgSize[0];
 			$height = $imgSize[1];

 			if ($width < $this->Width)
 			{
 				$this->Width = $width;
 			}
 			if ($height < $this->Height)
 			{
 				$this->Height = $height;
 			}

 			switch (strtolower($this->Extension))
 			{
  				case 'jpg':
  					$img = imagecreatefromjpeg($this->OriginalImage);
  					break;

  				case 'jpeg':
  					$img = imagecreatefromjpeg($this->OriginalImage);
  					break;

  				case 'gif':
  					$img = imagecreatefromgif($this->OriginalImage);
  					break;

  				case 'png':
  					$img = imagecreatefrompng($this->OriginalImage);
  					break;

  				default:
  					throw new Exception("File type not supported!");
 			}

 			if (($width >= $this->Width) || ($height >= $this->Height))
 			{
  				$mWidth = $this->Width / $width;
  				$mHeight = $this->Height / $height;

  				$mlt = $mWidth < $mHeight ? $mWidth : $mHeight;

     			if ($this->Width == "*")
     				$mlt = $mHeight;

     			if ($this->Height == "*")
     				$mlt = $mWidth;

     			if ($this->Width == "*" && $this->Height == "*")
     				$mlt = 1;

     			#### Calculate new dimensions
     			$img_new_w = round($width * $mlt);
     			$img_new_h = round($height * $mlt);

     			$img_resized = imagecreatetruecolor($img_new_w, $img_new_h);
     			imagecopyresampled($img_resized, $img, 0, 0, 0, 0, $img_new_w, $img_new_h, $width, $height);
     			imagejpeg($img_resized, $this->SavePath . '/' . $this->Filename, 90);
 			}
		}
	}
}
?>