<?php
/*
NetworX - open-source social networks platform
Copyright (C) 2009 SocialABC, Inc. http://www.socialabc.com
This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License along with this program in a file called LICENSE; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/ 

class ConnectionEntity extends Entity
{
	public function isBlocked($target)
	{
        $targetField = db_get_entity_key($target);
        if ($targetField == 'UserID' || $targetField == 'GroupID')
        {
            $targetField = 'To' . $targetField;
        }
		$connections = Connection::getConnections
		(
			array
			(
				$targetField	            => $target->{db_get_entity_key($target)},
				db_get_entity_key($this)	=> $this->{db_get_entity_key($this)},
				'ConnectionType'			=> CONNECTIONTYPE_BLOCKED
			)
		);
		return count($connections) > 0;
	}
    
	
	public function block($target)
	{
		if (!$this->isBlocked($target))
		{
            $targetField = db_get_entity_key($target);
            if ($targetField == 'UserID' || $targetField == 'GroupID')
            {
                $targetField = 'To' . $targetField;
            }
			$connection = new Connection();
			$connection->{$targetField}               = $target->{db_get_entity_key($target)};
			$connection->{db_get_entity_key($this)}	  = $this->{db_get_entity_key($this)};
			$connection->ConnectionType 			  = CONNECTIONTYPE_BLOCKED;
			$connection->saveToDB();
		}
	}                                                        
	
	public function unblock($target)
	{
		$this->removeConnection($target, CONNECTIONTYPE_BLOCKED);
	}
	
	public function removeConnection($target, $connectionType = -1)
	{
		$db = DBConnect::getInstance();
        $targetField = db_get_entity_key($target);                                     
        $field = db_get_entity_key($this);
        
        $db->query('delete from `connection` where (%f = %s or %f = %s) and (%f = %s or %f = %s)', 
        	$targetField, $target->{$targetField}, 'To' . $targetField, $target->{$targetField}, 
        	$field, $this->{$field}, 'To' . $field, $this->{$field});
	}
	
	public function delete()
	{
		$db = DBConnect::getInstance();
		$db->delete('connections', '%f = %d or %f = %d', db_get_entity_key($this), $this->{db_get_entity_key($this)}, 
			'To' . db_get_entity_key($this), $this->{db_get_entity_key($this)});
		parent::delete();
	}
}
?>