<?php
/*
NetworX - open-source social networks platform
Copyright (C) 2009 SocialABC, Inc. http://www.socialabc.com
This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License along with this program in a file called LICENSE; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/ 

class AdditionalStorage extends Entity
{
	public $AdditionalStorageID		= -1;
	public $ProductID				= -1;       
	public $AdditionalStorageSize	= 0;
	public $AdditionalStoragePrice	= 0;
	public $AdditionalStoragePeriod	= ADDITIONALSTORAGE_PERIOD_MONTH;

	public function getPeriodName()
	{
		switch ($this->AdditionalStoragePeriod)
		{
			case ADDITIONALSTORAGE_PERIOD_MONTH:
				return 'per month';
				
			case ADDITIONALSTORAGE_PERIOD_YEAR:
				return 'per year';   
		}
	}             
	
	public static function getAll()
	{
		return Entity::getAll('AdditionalStorage');    
	}
	
	public static function getByProductID($productID)
	{
		$db = DBConnect::getInstance();
		$result = $db->query('select * from additionalstorage where ProductID = %d', $productID);
		$return = new AdditionalStorage();
		if ($result->Size > 0)
		{
			$return->populateFromArray($result->Data[0]);
		}	
		return $return;
	}
}
?>