<?php
/*
NetworX - open-source social networks platform
Copyright (C) 2009 SocialABC, Inc. http://www.socialabc.com
This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License along with this program in a file called LICENSE; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/ 

class Comment extends Entity
{
	public $CommentID	= -1;
	public $ProductID	= -1;
	public $MarketID	= -1;
	public $PhotoID		= -1;
	public $UserID		= -1;
	public $CommentType	= COMMENT_TYPE_POSITIVE;
	public $CommentText	= '';
	public $CommentDate	= '';

	public function getUser()
	{
		return new User($this->UserID);
	}

	protected function addToDB($data)
	{
		$this->CommentDate = date('Y-m-d H:i:s');
		$data['CommentDate'] = $this->CommentDate;
		parent::addToDB($data);
	}

	static public function getPhotoComments($PhotoID = -1)
	{
		$db = DBConnect::getInstance();
		$return = array();
		$query = $db->query('SELECT c.*, u.UserFirstname, u.UserLastname FROM comment AS c JOIN user AS u USING (UserID) WHERE PhotoID = %d', $PhotoID);
		return $query->Data;
	}

	static public function getVideoComments($PhotoID = -1)
	{
		$db = DBConnect::getInstance();
		$return = array();
		$query = $db->query('SELECT c.*, u.UserEmail as Username FROM comment AS c JOIN user AS u USING (UserID) WHERE VideoID = %d', $PhotoID);
		return $query->Data;
	}

	static public function getPhotoCommentsCount($PhotoID = -1)
	{
		$db = DBConnect::getInstance();
		$return = array();
		$query = $db->query('SELECT COUNT(c.CommentID) AS ccount FROM comment AS c WHERE PhotoID = %d', $PhotoID);
		return $query->Data['0']['ccount'];
	}

	static public function getVideoCommentsCount($PhotoID = -1)
	{
		$db = DBConnect::getInstance();
		$return = array();
		$query = $db->query('SELECT COUNT(c.CommentID) AS ccount FROM comment AS c WHERE VideoID = %d', $PhotoID);
		return $query->Data['0']['ccount'];
	}

	static public function getNewUserPhotoCommentsCount($userID = -1)
	{
		$db = DBConnect::getInstance();
		$return = array();
		$query = $db->query('SELECT COUNT(c.CommentID) AS ccount FROM `comment` AS c WHERE (c.UserID = %d) AND (c.CommentDate <= %d) AND (c.PhotoID <> -1)', $userID, PROFILE_UPDATE_PERIOD);
		return $query->Data['0']['ccount'];
	}

	static public function getNewUserVideoCommentsCount($userID = -1)
	{
		$db = DBConnect::getInstance();
		$return = array();
		$query = $db->query('SELECT COUNT(c.CommentID) AS ccount FROM `comment` AS c WHERE (c.UserID = %d) AND (c.CommentDate <= %d) AND (c.VideoID <> -1)', $userID, PROFILE_UPDATE_PERIOD);
		return $query->Data['0']['ccount'];
	}

	public static function getSellerComments($seller)
	{
		$db = DBConnect::getInstance();

		$return = array();
		$result = $db->query('select c.* from product p inner join marketaccount m on m.MarketAccountID = p.MarketAccountID ' .
			'right join comment c on c.ProductID = p.ProductID where m.' . db_get_entity_key($seller) . ' = %d',
			$seller->{db_get_entity_key($seller)});

		foreach ($result->Data as $row)
		{
			$comment = new Comment();
			$comment->populateFromArray($row);
			$return[] = $comment;
		}

		return $return;
	}

	public static function getUserComments($user_id)
	{
		$db = DBConnect::getInstance();

		$return = array();
		$result = $db->query('SELECT * FROM `comment` WHERE UserID = %d', $user_id);

		foreach ($result->Data as $row)
		{
			$comment = new Comment();
			$comment->populateFromArray($row);
			$return[] = $comment;
		}

		return $return;
	}
}
?>