<?php
/*
NetworX - open-source social networks platform
Copyright (C) 2009 SocialABC, Inc. http://www.socialabc.com
This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License along with this program in a file called LICENSE; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/ 

class FormField Extends Entity
{
	public $FormFieldID		= -1;
	public $FormID			= -1;
	public $FormFieldName	= '';
	public $FormFieldType	= FORM_FIELD_TYPE_TEXT;


    public function getFormFields($form_id)
    {
        $result = array();

        $db = DBConnect::getInstance();
        $query = $db->query("SELECT * FROM `formfield` WHERE FormID = %d", $form_id);
        foreach ($query->Data as $row)
        {
            $field = new FormField();
            $field->populateFromArray($row);
            $result[] = $field;
        }

        return $result;
	}

    public function getFormFieldOptions()
    {
    	return FormFieldOption::getFormFieldOptions($this->FormFieldID);
	}

	public function clearFormFieldOptions()
	{
		$options = FormFieldOption::getFormFieldOptions($this->FormFieldID);
		foreach ($options as $option)
		{
			$option->delete();
		}
	}

	public function delete()
	{
		$options = FormFieldOption::getFormFieldOptions($this->FormFieldID);
		foreach ($options as $option)
		{
			$option->delete();
		}
		parent::delete();
	}
}
?>