<?php
/*
NetworX - open-source social networks platform
Copyright (C) 2009 SocialABC, Inc. http://www.socialabc.com
This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License along with this program in a file called LICENSE; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/ 

class Location extends Entity
{
	public $LocationID 			= -1;
	public $GroupID				= -1;
	public $OrganizationID		= -1;
	public $LocationCountry		= '';
	public $LocationName		= '';
	public $LocationStreet		= '';
	public $LocationCity		= '';
	public $LocationState		= 0;


	public static function getGroupLocations($groupID)
	{
		$return = array();

		$db = DBConnect::getInstance();
		$result = $db->query('SELECT * FROM `location` WHERE GroupID = %d', $groupID);
		foreach ($result->Data as $row)
		{
			$location = new Location();
			$location->populateFromArray($row);

			$return[] = $location;
		}

		return $return;
	}

	public static function getOrganizationLocations($organization_id)
	{
		$return = array();

		$db = DBConnect::getInstance();
		$result = $db->query('SELECT * FROM `location` WHERE OrganizationID = %d', $organization_id);

		foreach ($result->Data as $row)
		{
			$location = new Location();
			$location->populateFromArray($row);

			$return[] = $location;
		}

		return $return;
	}

	public static function clearGroupLocations($group_id)
	{
		$db = DBConnect::getInstance();
		$db->delete('location', 'GroupID = %d', $group_id);
	}

	public static function clearOrganizationLocations($organization_id)
	{
		$result = false;

		$db = DBConnect::getInstance();
		$result = $db->delete('location', 'OrganizationID = %d', $organization_id);

		return $result;
	}
}
?>