<?php
/*
NetworX - open-source social networks platform
Copyright (C) 2009 SocialABC, Inc. http://www.socialabc.com
This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License along with this program in a file called LICENSE; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/ 

class NewsDraft extends Entity
{
	public $NewsDraftID			= -1;
	public $GroupID 			= -1;
	public $UserID 				= -1;
	public $OrganizationID		= -1;
	public $CommunityID			= -1;
	public $NewsDate			= CURRENT_TIME;
	public $NewsName			= '';
	public $NewsKeywords		= '';
	public $NewsText			= '';


	public function populateFromArray($data)
    {
        parent::populateFromArray($data);
        $this->NewsText = html_entity_decode($this->NewsText);
    }

	public static function getGroupNews($grid = 0, $userID)
	{
		$result = array();
		$db = DBConnect::getInstance();
		$res = $db->query("select * from `news` where `GroupID`=%s and UserID=%s", $grid, $userID);
		foreach ($res->Data as $row)
		{
			$news = new News(-1);
			$news->populateFromArray($row);
			$result[] = $news;
		}
		return $result;
	}

	public static function getCommunityNews($grid = -1)
	{
		$result = array();
		$db = DBConnect::getInstance();
		$res = $db->query("select * from `news` where `CommunityID` = %s", $grid);
		foreach ($res->Data as $row)
		{
			$news = new News(-1);
			$news->populateFromArray($row);
			$result[] = $news;
		}
		return $result;
	}

	public static function getOrganizationNews($grid = -1)
	{
		$result = array();
		$db = DBConnect::getInstance();
		$res = $db->query("select * from `news` where `OrganizationID`=%s", $grid);
		foreach ($res->Data as $row)
		{
			$news = new News(-1);
			$news->populateFromArray($row);
			$result[] = $news;
		}
		return $result;
	}

	public function deleteNewsDrafts($drafts)
	{
		$db = DBConnect::getInstance();

		foreach ($drafts as $draft_id)
		{
			$db->delete('newsdraft', 'NewsDraftID = ' . $draft_id);
		}
	}

	public static function submitNewsDrafts($drafts)
	{
        $db = DBConnect::getInstance();

		foreach ($drafts as $draft_id)
		{
			$result = $db->query("SELECT GroupID, UserID, OrganizationID, CommunityID, NewsDate, NewsName, NewsKeywords, NewsText FROM `newsdraft` WHERE NewsDraftID=%d", $draft_id);
			$news = new News(-1);
			$news->GroupID = $result->Data[0]['GroupID'];
			$news->UserID = $result->Data[0]['UserID'];
			$news->OrganizationID = $result->Data[0]['OrganizationID'];
			$news->CommunityID = $result->Data[0]['CommunityID'];
			$news->NewsDate = $result->Data[0]['NewsDate'];
			$news->NewsName = $result->Data[0]['NewsName'];
			$news->NewsKeywords = $result->Data[0]['NewsKeywords'];
			$news->NewsText = $result->Data[0]['NewsText'];
			$news->saveToDB();
			$db->query("DELETE FROM `newsdraft` WHERE NewsDraftID=%d", $draft_id);
		}
	}
}
?>