<?php
/*
NetworX - open-source social networks platform
Copyright (C) 2009 SocialABC, Inc. http://www.socialabc.com
This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License along with this program in a file called LICENSE; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/ 


function forum_insertforum($forum_name, $forum_type)
{
    $db = DBConnect::getInstance();

	$sql = 'SELECT left_id, right_id, forum_type
		FROM phpbb_forums
		WHERE forum_id = %d';
	$res = $db->query($sql, $forum_type);
	$sql = 'UPDATE phpbb_forums
		SET left_id = left_id + 2, right_id = right_id + 2
		WHERE left_id > %d';
	$db->query($sql, $res->Data[0]['right_id']);

	$sql = 'UPDATE phpbb_forums
		SET right_id = right_id + 2
		WHERE %d BETWEEN left_id AND right_id';
	$db->query($sql, $res->Data[0]['right_id']);

	$left_id = $res->Data[0]['right_id'];
	$right_id = $res->Data[0]['right_id'] + 1;

	$sql = "INSERT INTO phpbb_forums (parent_id, forum_type, forum_status, forum_parents, forum_name, forum_link, forum_desc, forum_desc_uid, forum_desc_options, forum_desc_bitfield, forum_rules, forum_rules_uid, forum_rules_options, forum_rules_bitfield, forum_rules_link, forum_image, forum_style, display_subforum_list, display_on_index, forum_topics_per_page, enable_indexing, enable_icons, enable_prune, prune_days, prune_viewed, prune_freq, forum_flags, left_id, right_id) VALUES (%d, 1, 0, '', %s, '', '', '', 7, '', '', '', 7, '', '', '', 0, 1, 0, 0, 1, 0, 0, 7, 7, 1, 32, %d, %d)";
    $db->query($sql, $forum_type, htmlspecialchars($forum_name), $left_id, $right_id);
    $id = mysql_insert_id();
    forum_set_permissions($id, $forum_type);

    $dir = @opendir('./forum/cache');
    if ($dir)
    {
	    while ($file = readdir($dir))
	    {
	        if (strpos($file, '.php') !== FALSE)
	        {
	            @unlink('./forum/cache/' . $file);
			}
		}
	    closedir($dir);
	}

    return $id;
}

function forum_set_permissions($forum_id, $forum_perm_from)
{
    $db = DBConnect::getInstance();
	$sql = 'SELECT user_id, auth_option_id, auth_role_id, auth_setting
		FROM phpbb_acl_users
		WHERE forum_id = %d';
    $res = $db->query($sql, $forum_perm_from);
	foreach ($res->Data as $row)
	{
	    $sql = "insert into phpbb_acl_users set " .
	    "user_id = %d, " .
	    "auth_option_id = %d, " .
	    "auth_role_id = %d, " .
	    "auth_setting = %d, " .
	    "forum_id = %d";
	    $db->query($sql, $row['user_id'], $row['auth_option_id'], $row['auth_role_id'], $row['auth_setting'], $forum_id);
	}
	$sql = 'SELECT group_id, auth_option_id, auth_role_id, auth_setting
		FROM phpbb_acl_groups
		WHERE forum_id = %d';
    $db = DBConnect::getInstance();
    $res = $db->query($sql, $forum_perm_from);
	foreach ($res->Data as $row)
	{
	    $sql = "insert into phpbb_acl_groups set " .
	    "group_id = %d, " .
	    "auth_option_id = %d, " .
	    "auth_role_id = %d, " .
	    "auth_setting = %d, " .
	    "forum_id = %d";
	    $db->query($sql, $row['group_id'], $row['auth_option_id'], $row['auth_role_id'], $row['auth_setting'], $forum_id);
	}
}

function forum_get_posts_count($email)
{
	$db = DBConnect::getInstance();
	$sql = 'select count(*) as cnt from phpbb_posts p inner join phpbb_users u on (p.poster_id = u.user_id) where u.user_email = %s';
	$res = $db->query($sql, $email);
	$count = $res->Data[0]['cnt'];
	return $count;
}

function forum_get_posts_count_rank($email)
{
    $db = DBConnect::getInstance();
	$sql = 'select u.user_email, count(post_id) as cnt from phpbb_posts p inner join phpbb_users u on (p.poster_id = u.user_id) group by u.user_email order by cnt asc';
	$res = $db->query($sql);
    for ($i = 0; $i < count($result->Data); $i++)
    {
        if ($userID == $result->Data[$i]['user_email'])
        {
            break;
        }
    }
    return $i + 1;
}

function forum_get_all_posts()
{
	$db = DBConnect::getInstance();
	$sql = 'select count(*) as cnt from phpbb_posts';
	$res = $db->query($sql);
	$count = $res->Data[0]['cnt'];
	return $count;
}

?>
