<?php
/*
NetworX - open-source social networks platform
Copyright (C) 2009 SocialABC, Inc. http://www.socialabc.com
This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License along with this program in a file called LICENSE; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/ 


function wiki_add_group(Group $group)
{
	if(!defined('DOKU_INC')) define('DOKU_INC',dirname(__FILE__).'/../../wiki/');
	require_once(DOKU_INC.'inc/init.php');
	require_once(DOKU_INC.'inc/common.php');
	require_once(DOKU_INC.'inc/events.php');
	require_once(DOKU_INC.'inc/pageutils.php');
	require_once(DOKU_INC.'inc/html.php');
	require_once(DOKU_INC.'inc/auth.php');
	require_once(DOKU_INC.'inc/actions.php');

	$id = wiki_translate('Groups:' . $group->GroupName);
	wiki_add_page($id . ':start', '====== ' . $group->GroupName . ' WIKI ======');
	if ($group->GroupType == GROUP_TYPE_PUBLIC)
	{
		wiki_set_perm($id . ':*', '@ALL', 8);
	}
	else
	{
		wiki_set_perm($id . ':*', '@' . auth_nameencode('Group:' . $group->GroupName), 8);
		wiki_set_perm($id . ':*', '@ALL', 1);
	}
}

function wiki_add_community(Community $community)
{
	if(!defined('DOKU_INC')) define('DOKU_INC',dirname(__FILE__).'/../../wiki/');
	require_once(DOKU_INC.'inc/init.php');
	require_once(DOKU_INC.'inc/common.php');
	require_once(DOKU_INC.'inc/events.php');
	require_once(DOKU_INC.'inc/pageutils.php');
	require_once(DOKU_INC.'inc/html.php');
	require_once(DOKU_INC.'inc/auth.php');
	require_once(DOKU_INC.'inc/actions.php');

	$id = wiki_translate('Communities:' . $community->CommunityName);
	wiki_add_page($id . ':start', '====== ' . $community->CommunityName . ' WIKI ======');
	wiki_set_perm($id . ':*', '@ALL', 8);
}

function wiki_add_organization(Organization $organization)
{
	if(!defined('DOKU_INC')) define('DOKU_INC',dirname(__FILE__).'/../../wiki/');
	require_once(DOKU_INC.'inc/init.php');
	require_once(DOKU_INC.'inc/common.php');
	require_once(DOKU_INC.'inc/events.php');
	require_once(DOKU_INC.'inc/pageutils.php');
	require_once(DOKU_INC.'inc/html.php');
	require_once(DOKU_INC.'inc/auth.php');
	require_once(DOKU_INC.'inc/actions.php');

	$id = wiki_translate('Organizations:' . $organization->OrganizationName);
	wiki_add_page($id . ':start', '====== ' . $organization->OrganizationName . ' WIKI ======');
	if ($group->GroupType == GROUP_TYPE_PUBLIC)
	{
		wiki_set_perm($id . ':*', '@ALL', 8);
	}
	else
	{
		wiki_set_perm($id . ':*', '@' . auth_nameencode('Organization:' . $organization->OrganizationName), 8);
		wiki_set_perm($id . ':*', '@ALL', 1);
	}}

function wiki_add_page($page, $body)
{
	if(!defined('DOKU_INC')) define('DOKU_INC',dirname(__FILE__).'/../../wiki/');
	require_once(DOKU_INC.'inc/init.php');
	require_once(DOKU_INC.'inc/common.php');
	require_once(DOKU_INC.'inc/events.php');
	require_once(DOKU_INC.'inc/pageutils.php');
	require_once(DOKU_INC.'inc/html.php');
	require_once(DOKU_INC.'inc/auth.php');
	require_once(DOKU_INC.'inc/actions.php');
	
	$ID 	= $page;
	$PRE 	= '';
	$TEXT 	= $body;
	$SUF 	= '';
	$SUM 	= 'created';

	saveWikiText($ID,con($PRE,$TEXT,$SUF,1),$SUM,NULL); //use pretty mode for con
	unlock($ID);
	act_draftdel($act);
}

function wiki_set_perm($acl_scope, $acl_user, $acl_level)
{
	if(!defined('DOKU_INC')) define('DOKU_INC',dirname(__FILE__).'/../../wiki/');
	require_once(DOKU_INC.'inc/init.php');
	require_once(DOKU_INC.'inc/common.php');
	require_once(DOKU_INC.'inc/events.php');
	require_once(DOKU_INC.'inc/pageutils.php');
	require_once(DOKU_INC.'inc/html.php');
	require_once(DOKU_INC.'inc/auth.php');
	require_once(DOKU_INC.'inc/actions.php');

	$acl_config = file_get_contents(DOKU_CONF.'acl.auth.php');
	$acl_user = auth_nameencode($acl_user,true);

	// max level for pagenames is edit
	if(strpos($acl_scope,'*') === false) {
	    if($acl_level > AUTH_EDIT) $acl_level = AUTH_EDIT;
	}


	$new_acl = "$acl_scope\t$acl_user\t$acl_level\n";

	$new_config = $acl_config.$new_acl;

	return io_saveFile(DOKU_CONF.'acl.auth.php', $new_config);
}  

function wiki_delete_perm($acl_scope, $acl_user)
{
    $acl_config = file(DOKU_CONF.'acl.auth.php');
    $acl_user = auth_nameencode($acl_user,true);

    $acl_pattern = '^'.preg_quote($acl_scope,'/').'\s+'.$acl_user.'\s+[0-8].*$';

    // save all non!-matching
    $new_config = preg_grep("/$acl_pattern/", $acl_config, PREG_GREP_INVERT);

    return io_saveFile(DOKU_CONF.'acl.auth.php', join('',$new_config));

}

function wiki_translate($name)
{
	if(!defined('DOKU_INC')) define('DOKU_INC',dirname(__FILE__).'/../../wiki/');
	require_once(DOKU_INC.'inc/init.php');
	require_once(DOKU_INC.'inc/common.php');
	require_once(DOKU_INC.'inc/events.php');
	require_once(DOKU_INC.'inc/pageutils.php');
	require_once(DOKU_INC.'inc/html.php');
	require_once(DOKU_INC.'inc/auth.php');
	require_once(DOKU_INC.'inc/actions.php');

	global $conf;

	$id = $name;

	$id = cleanID($id);
	
	if(empty($id)) 
	{
		$id = $conf['start'];
	}

	return $id;
}

?>
