<?php
/*
NetworX - open-source social networks platform
Copyright (C) 2009 SocialABC, Inc. http://www.socialabc.com
This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License along with this program in a file called LICENSE; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/ 

include('includes/application_top.php');
$template->loadTemplateFile("photo_report.html");

if (!Session::isCurrentSessionLoggedIn())
{
	cmn_unathorized_action();
}

if (UserBlock::checkUserBlockResources(USER_BLOCKED_RESOURCES, USERBLOCK_RESOURCE_MEDIA))
{
    cmn_unathorized_action();
}

$photoid = isset($_GET['photo_id']) ? $_GET['photo_id'] : ( isset($_POST['photo_id']) ? $_POST['photo_id'] : -1);
$photo = new Photo($photoid);
if ($photo->PhotoID == -1)
{
	cmn_unathorized_action();
}
$album = new Album($photo->AlbumID);
if (!$album->checkPermission('view'))
{
	cmn_unathorized_action();
}

if (isset($_POST['submited']))
{
	$owner = $album->getOwner();
	while (get_class($owner) != 'User')
	{
		$owner = $owner->getOwner();
	}
	Message::sendUserMessage($owner->UserID, $user->UserID,
		'Photo ' . $photo->PhotoName . ': violation report',
		'User ' . db_get_entity_display_name($user) . " reports you about a violation in this photo: \n" . $_POST['MessageText']);

    $complaint = new Complaint();
    $complaint->UserID            = $user->UserID;
    $complaint->ComplaintSource   = COMPLAINT_SOURCE_PHOTO;
    $complaint->ComplaintSourceID = $photo->PhotoID;
    $complaint->ComplaintStatus   = COMPLAINT_STATUS_NEW;
    $complaint->ComplaintMessage  = $_POST['MessageText'];
    $complaint->saveToDB();

	$template->touchBlock('success');
}
else
{
	$template->touchBlock('report_form');
}
$template->setVariable('PhotoName', $photo->PhotoName);

include('includes/application_bottom.php');