<?php
/*
NetworX - open-source social networks platform
Copyright (C) 2009 SocialABC, Inc. http://www.socialabc.com
This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License along with this program in a file called LICENSE; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/ 

include('includes/application_top.php');
$template->loadTemplateFile('tagging_screen.html');
if (!Session::isCurrentSessionLoggedIn())
{
	cmn_unauthorized_action();
}

if (!($_GET['tag_type'] && $_GET['id']) && !$_POST['submitted'])
{
	// closing window
	$template->touchBlock('close_window');
	exit;
}

$template->setGlobalVariable('tag_type', $_GET['tag_type']);
$template->setGlobalVariable('object_id', $_GET['id']);

if ($_POST['submitted'] == 'true')
{
	$tag = new Tag();

	$tag_name = $_POST['TagName'];
	$individual = User::getByUsername($_POST['IndividualName']);
	$group = Group::getByGroupName($_POST['GroupName']);
	$organization = Organization::getByOrganizationName($_POST['OrganizationName']);
	$community = Community::getByCommunityName($_POST['CommunityName']);

	// saving tag information
	$tag->TagName = $tag_name;
	$tag->ObjectID = $_POST['object_id'];
	$tag->UserID = $individual->UserID;
	$tag->GroupID = $group->GroupID;
	$tag->OrganizationID = $organization->OrganizationID;
	$tag->CommunityID = $community->CommunityID;
	$tag->TagKeywords = $_POST['TagKeywords'];

	$tag->TagType = $_POST['tag_type'];
	$tag->saveToDB();

	if ($tag->UserID > 0)
	{
		Message::sendUserTaggingRequest($user->UserID, $individual->UserID, $_POST['tag_type'], $_POST['object_id'], $tag->TagID);
	}
	if ($tag->GroupID > 0)
	{
		Message::sendGroupTaggingRequest($user->UserID, $group->GroupID, $_POST['tag_type'], $_POST['object_id'], $tag->TagID);
	}
	if ($tag->OrganizationID > 0)
	{
		Message::sendOrganizationTaggingRequest($user->UserID, $organization->OrganizationID, $_POST['tag_type'], $_POST['object_id'], $tag->TagID);
	}

	$tag_location_countries = $_POST['TagLocationCountries'];
	$tag_location_states = $_POST['TagLocationStates'];
	$tag_location_cities = $_POST['TagLocationCities'];
	$tag_location_neighborhoods = $_POST['TagLocationNeighborhoods'];

	// saving tag locations
	for ($i=0; $i<count($tag_location_countries); $i++)
	{
		$tag_location = new TagLocation();

		$tag_location->TagID = $tag->TagID;
		$tag_location->TagLocationCountry = $tag_location_countries[$i];
		$tag_location->TagLocationState = $tag_location_states[$i];
		$tag_location->TagLocationCity = $tag_location_cities[$i];
		$tag_location->TagLocationNeighborhood = $tag_location_neighborhoods[$i];

		$tag_location->saveToDB();
	}

	if ($_POST['TagConnectionPrivacyFlag'] == TAG_PRIVACY_PRIVATE)
	{
		$tag_id = $tag->TagID;

		Tag::togglePrivacyFlagState($tag_id, PRIVACY_FLAG_TAG_SET);

		// get organization id's
		$organizations = $_POST['OrganizationID'];

		foreach ($organizations as $organization_id)
		{
			Tag::allowOrganizationsMembersToViewThisTag($organization_id, $tag_id);
		}

		// get group id's
		$groups = $_POST['GroupID'];

		foreach ($groups as $group_id)
		{
			Tag::allowGroupMembersToViewThisTag($group_id, $tag_id);
		}

		// get individual id's
		$people = $_POST['Individuals_items'];

		foreach ($people as $user_id)
		{
			Tag::allowUserToViewThisTag($user_id, $tag_id);
		}
	}

	// closing window
	$template->touchBlock('close_window');
}

// rendering countries
foreach ($COUNTRIES as $code => $country)
{
	$template->setVariable(array(
		'key' => $code,
		'value' => $country,
	));
	$template->parse('country');
}

// rendering states
foreach ($STATES as $code => $state)
{
	$template->setVariable(array(
		'key' => $code,
		'value' => $state,
	));
	$template->parse('state');
}

$template->setGlobalVariable('tag_privacy_public', TAG_PRIVACY_PUBLIC);
$template->setGlobalVariable('tag_privacy_private', TAG_PRIVACY_PRIVATE);

// display user organizations
$organizations = $user->getOrganizations();

foreach ($organizations as $organization)
{
	$template->setVariable('OrganizationID', $organization->OrganizationID);
	$template->setVariable('OrganizationName', $organization->OrganizationName);

	$template->parse('Organization');
}

// display user groups
$groups = $user->getGroups();

foreach ($groups as $group)
{
	$template->setVariable('GroupID', $group->GroupID);
	$template->setVariable('GroupName', $group->GroupName);

	$template->parse('Group');
}

// display users (individuals)
$individuals = $user->getConnectedUsers();

foreach ($individuals as $individual)
{
	$template->setVariable('IndividualID', $individual->UserID);
	$template->setVariable('IndividualName', db_get_entity_display_name($individual));

	$template->parse('Individual');
}

$template->setVariable('privacy_type', $_GET['privacy_type']);

include('includes/application_bottom.php');