<?php
/*
NetworX - open-source social networks platform
Copyright (C) 2009 SocialABC, Inc. http://www.socialabc.com
This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License along with this program in a file called LICENSE; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/ 

include('includes/application_top.php');
if ($user->isAuthorised())
{

	$is_new = ($_GET['video_album_id'] > 0) ? false : true;
    $video_album = new VideoAlbum($_GET['video_album_id']);
    $type  = 'user';
    $id    = $user->UserID;
    $owner = $user;
    $ownerEntity = '';

    if ($video_album->VideoAlbumID == -1)
    {
        $type = $_GET['type'] ? $_GET['type'] : $type;
        $id   = $_GET['id'] ? $_GET['id'] : $id;
        $ownerEntity    = ucfirst($type);
    	$owner = new $ownerEntity($id);
    }
    else
    {
        $owner = $video_album->getOwner();
        $ownerEntity    = get_class($owner);
        $type = strtolower($ownerEntity);
        $id   = $owner->{ucfirst(get_class($owner)) . 'ID'};
    }

    if (strtolower($type) != 'user')
    {
        $template->setVariable('Entity', $type);
        $template->setVariable('EntityID',   $id);
        $template->parse('back_link');
    }

    if ($owner->checkActionPermission('create_video_album'))
    {
        $data = $video_album->getDataArray();
        if (isset($_POST['submitted']))
        {
            $error = false;
            foreach ($data as $key => $value)
            {
                if (isset($_POST[$key]))
                {
                       $data[$key] = $_POST[$key];
                }
                switch ($key)
                {
                    case "VideoAlbumName":
                        if (!$data[$key])
                        {
                            $error = true;
                            $template->touchBlock("err_" . $key);
                        }
                        break;
                    case "VideoAlbumDescription":
                        if (!$data[$key])
                        {
                            $error = true;
                            $template->touchBlock("err_" . $key);
                        }
                        break;
                }
            }
            $video_album->populateFromArray($data);
            $video_album->{$ownerEntity . 'ID'} = $id;
            $video_album->setOwner($type, $id);

            if (isset($_POST['visibleall']))
            {
                $video_album->VideoAlbumPrivacy = PRIVACY_PUBLIC;
                $template->touchBlock('privacy_public');
            }
            if (!$error)
            {
            	$video_album->saveToDB();

                Connection::clearVideoAlbumPrivacy('VideoAlbum', $video_album->VideoAlbumID);
                if ($video_album->VideoAlbumPrivacy == PRIVACY_PRIVATE)
                {
                    foreach (array('Group', 'Organization', 'User') as $targetEntity)
                    {
                        if (is_array(@$_POST[$targetEntity . 'ID']))
                        {
                            foreach ($_POST[$targetEntity . 'ID'] as $targetID)
                            {
                                $target = Entity::getObject($targetEntity, $targetID);
                                if ($target->{db_get_entity_key($target)} != -1)
                                {
                                    Connection::createVideoAlbumPrivacyConnection($video_album->VideoAlbumID, $targetEntity, $targetID);
                                }
                            }
                        }
                    }
                }

	            if ($is_new)
	            {
            		cmn_redirect('video_album_upload.php?video_album_id=' . $video_album->VideoAlbumID);
	            }
	            else
	            {
            		cmn_redirect('video_albums.php?type=' . $type . '&id=' . $id);
	            }
                
            }
        }
        if ($video_album->VideoAlbumPrivacy == PRIVACY_PUBLIC)
        {
            $template->touchBlock('privacy_public');
        }
        $template->setVariable($data);
        $control = new MyConnections('PRIVACY', 'control.myconnections_select.html');
        $control->parse($template, $user->UserID, 0);

    }
    else
    {
        cmn_unathorized_action();
    }
}
else
{
    cmn_unathorized_action();
}
include('includes/application_bottom.php');
?>